unit Prg07Dll;
////////////////////////////////////////////////////////////////////////////////
///
///              
///
///     ,      
///
////////////////////////////////////////////////////////////////////////////////


                               interface
////////////////////////////////////////////////////////////////////////////////
uses
  SysUtils;

////////////////////////////////////////////////////////////////////////////////
//                       
////////////////////////////////////////////////////////////////////////////////
const
  RES_NO_ERROR           = 0;
  RES_INVALID_PARAM      = 1;
  RES_INVALID_COMMAND    = 2;
  RES_BAD_CRC            = 3;
  RES_TIMEOUT            = 4;
  RES_INTERFACE_ERR      = 5;
  RES_NO_DATA            = 6;

////////////////////////////////////////////////////////////////////////////////
//                    -  0x30
////////////////////////////////////////////////////////////////////////////////
const
  TRN_NEW_TAG_FOUND       = $3001;
  TRN_TAG_LOSS            = $3002;
  TRN_DC_IS_ON            = $3003;
  TRN_DC_IS_OFF           = $3004;
  TRN_SENS_IS_ON          = $3005;
  TRN_SENS_IS_OFF         = $3006;
  TRN_SEND_TAG_1          = $3007;
  TRN_SEND_TAG_2          = $3008;
  TRN_LOCKED              = $3009;
  TRN_UNLOCKED            = $300A;
  TRN_SET_ON              = $300B;
  TRN_SET_OFF             = $300C;
  TRN_TAG_IN_OPPOSIT      = $300D;
  TRN_STACK_CLEARED       = $300E;
  TRN_TAG_REMOVED         = $300F;
  TRN_WAIT_CAR            = $3010;
  TRN_WAIT_ACCESS         = $3011;
  TRN_WAIT_DEF_GATE       = $3012;
  TRN_WAIT_GATE_CLOSE     = $3013;
  TRN_ACCESS_FINISH       = $3014;
  TRN_CAR_NOT_FOUND       = $3015;
  TRN_GATE_NOT_OPEN       = $3016;
  TRN_GATE_NOT_CLOSE      = $3017;
  TRN_WAIT_DEF_ACCESS     = $3018;
  TRN_STACK_OVERFLOW      = $3019;
////////////////////////////////////////////////////////////////
//    -  0x31
////////////////////////////////////////////////////////////////
  TRN_BATT_LOW            = $3101;
  TRN_BATT_NORM           = $3102;
  TRN_CONTROLLER_ON       = $3103;
  TRN_CONTROLLER_OFF      = $3104;


//    
type
  TTransaction = packed record
    addr: byte;
    srcname: byte;
    srcnumber: byte;
    entname: byte;
    entnumber: byte;
    code: WORD;
    year: word;
    month: byte;
    day: byte;
    hour: byte;
    minute: byte;
    sec: byte;
    card: uint32;
    extdata: uint32;
  end;
  PTransaction = ^TTransaction;

//     
type
  TVersion = packed record
    dev_id: word;       // ID  
    devtype: byte;      //  
    svsoft: byte;       //   
    svhard: byte;       //   
    verhi: byte;        //   
    verlo: byte;        //   
  end;
  PVersion = ^TVersion;

//    
type
  //     0,1 
  TAccessConfig = packed record
    //   ( 16   )
    CheckOpposit      : byte;       //     
    UseCarSensor      : byte;       //   
    CarSensInversion  : byte;       //   
    UseGateSensor     : byte;       //   
    GateSensInversion : byte;       //   
    ResetTimeByDc     : byte;       //     
    RemovePassedTag   : byte;       //    
    NoReadWhileAccess : byte;       //      
    UseButtonDir      : byte;       //     
    //  
    TagWaitTime       : word;       //    
    CarWaitTime       : word;       //    
    AccWaitTime       : word;       //   
    GateOpenTime      : word;       //   
    AccDefaultTime    : word;       //     ( )
    Reserv1           : word;
    Reserv2           : word;
  end;
  PAccessConfig = ^TAccessConfig;

//   
type
  TNetConfig = packed record
    IpAddr: array[0..3] of byte;
    GateIp: array[0..3] of byte;
    NetMask: array[0..3] of byte;
    ServerIp: array[0..3] of byte;
    PrimaryDns: array[0..3] of byte;
    SecondaryDns: array[0..3] of byte;
    MacAddr: array[0..5] of byte;
  end;
  PNetConfig = ^TNetConfig;

const
  DLL_NAME = 'PRG07N.dll';

////////////////////////////////////////////////////////////////////////////////
function SetDateTime(addr: word; time: uint32; date: uint32): word; stdcall; external DLL_NAME;
function GetDateTime(addr: word; var time: uint32; var date: uint32): word; stdcall; external DLL_NAME;

function GetNumTags(addr: word; chan: word; var num: word): word; stdcall; external DLL_NAME;
function GetFirstTag(addr: word; chan: word; var tag: uint32): word; stdcall; external DLL_NAME;
function GetNextTag(addr: word; chan: word; var tag: uint32): word; stdcall; external DLL_NAME;
//
function GetDumping(addr: word; chan: word; var dump: word): word; stdcall; external DLL_NAME;
function SetDumping(addr: word; chan: word; dump: word): word; stdcall; external DLL_NAME;
function GetTagMemTime(addr: word; chan: word; var time: word): word; stdcall; external DLL_NAME;
function SetTagMemTime(addr: word; chan: word; time: word): word; stdcall; external DLL_NAME;
function SetTagOutInterval(addr: word; time: word): word; stdcall; external DLL_NAME;
//
function SetInputLevel(addr: word; name: word; number: word; data: word): word; stdcall; external DLL_NAME;
//
function GetRadioConfig(addr: word; chan: word; data: pbytearray): word; stdcall; external DLL_NAME;
function SetRadioConfig(addr: word; chan: word; data: pbytearray): word; stdcall; external DLL_NAME;
//
function GetNetworkConfig(addr: word; data: pbytearray): word; stdcall; external DLL_NAME;
function SetNetworkConfig(addr: word; data: pbytearray; len: word): word; stdcall; external DLL_NAME;

//    
function ReadSerial(addr: word; ser: pbytearray): word; stdcall; external DLL_NAME;
function WriteSerial(addr: word; ser: pbytearray): word; stdcall; external DLL_NAME;
//
function SendSimpleCommand(addr: word; code: word; name: word; number: word): word; stdcall; external DLL_NAME;
//
function AskTransaction(addr: word; var tran: TTransaction): word; stdcall; external DLL_NAME;
//
function StartRadioTest(addr: word; chan: word; etalontag: uint32; testtag: uint32): word; stdcall; external DLL_NAME;
function StopRadioTest(addr: word; var chan: word; var etaloncount: word; var testcount: word): word; stdcall; external DLL_NAME;
//
function GetVersion(addr: word; ver: PVersion): word; stdcall; external DLL_NAME;
function GetVersionStr(addr: word; ver: pbytearray): word; stdcall; external DLL_NAME;
//
function GetInputsState(addr: word; var stat: word): word; stdcall; external DLL_NAME;
//
function SetChannelActivity(addr: word; chan: word; state: word): word; stdcall; external DLL_NAME;
function SetStackLocked(addr: word; chan: word; state: word): word; stdcall; external DLL_NAME;
function GetRfChannelsStat(addr: word; var actch1: word; var actch2: word;
                           var locked1: word; var locked2: word): word; stdcall; external DLL_NAME;
//
function SetAccessConfig(addr: word; chan: word; cfg: PAccessConfig): word; stdcall; external DLL_NAME;
function GetAccessConfig(addr: word; chan: word; cfg: PAccessConfig): word; stdcall; external DLL_NAME;
//
function SetDeviceMode(addr: word; mode: word): word; stdcall; external DLL_NAME;
function GetDeviceMode(addr: word; var mode: word): word; stdcall; external DLL_NAME;

//    RS-485     
function GetReaderAddr(var adr: word): word; stdcall; external DLL_NAME;
function SetReaderAddr(addr: word; newadr: word): word; stdcall; external DLL_NAME;

//     WEB
function ClearWebPassword(addr: word): word; stdcall; external DLL_NAME;
function SetWebPassword(addr: word; buf: pbytearray; len: word): word; stdcall; external DLL_NAME;

//   
function SetRelayParams(addr: word; num: word; tim: word): word; stdcall; external DLL_NAME;
function SetRelayActivity(addr: word; lock: word; aux: word): word; stdcall;  external DLL_NAME;
function GetRelayParams(addr: word; var aux: word; var lock: word; var t1: word; var t2: word): word; stdcall; external DLL_NAME;

//    
function ResetReaderParams(addr: word): word; stdcall; external DLL_NAME;

function ClearTransactions(addr: word): word; stdcall; external DLL_NAME;
//   
function GetTranCount(addr: word; var cnt: word): word; stdcall; external DLL_NAME;

//     
function GetWebName(addr: word; buf: pbytearray): word; stdcall; external DLL_NAME;
function SetWebName(addr: word; buf: pbytearray; len: word): word; stdcall; external DLL_NAME;


//  IP-DLL - 
function SetServerIp(ipadr: uint32): word; stdcall; external DLL_NAME;
function SetReaderIp(ipadr: uint32): word; stdcall; external DLL_NAME;
function GetReaderIp(var ipadr: uint32): word; stdcall; external DLL_NAME;

//    DLL
function DllStart(usethernet: word): word; stdcall; external DLL_NAME;
function DllStop(): word; stdcall; external DLL_NAME;

function DllStarted(): word; stdcall; external DLL_NAME;

//   
function StartTest(addr: word; var dat: int64): word; stdcall; external DLL_NAME;
function TstReadInputs(addr: word; var dat: int64): word; stdcall; external DLL_NAME;
function TstSetOutputs(addr: word; dat: int64): word; stdcall; external DLL_NAME;
//
function TstSetMacAddr(addr: word; dat: int64): word; stdcall; external DLL_NAME;
function TstSetSerial(addr: word; dat: int64): word; stdcall; external DLL_NAME;
function TstStoreNetPrams(addr: word): word; stdcall; external DLL_NAME;
//
function TstStopTest(addr: word): word; stdcall; external DLL_NAME;
function TstReboot(addr: word): word; stdcall; external DLL_NAME;
//
function StatRadioTestStart(addr: word): word; stdcall; external DLL_NAME;
function StatRadioTestStop(addr: word; var numtag: word; var numdr: word; var maxdiff: word): word; stdcall; external DLL_NAME;


function Dummy(): word; stdcall; external DLL_NAME;

                             implementation
////////////////////////////////////////////////////////////////////////////////

                           initialization
////////////////////////////////////////////////////////////////////////////////
// begin

// end initialization;

finalization
////////////////////////////////////////////////////////////////////////////////
// begin

// end finalization;

end.

